package mx.rpc.xml
{
   public class DataType
   {
      public static var objectType:DataType;
      
      public static var xmlType:DataType;
      
      public static var functionType:DataType;
      
      public static var NUMBER_TYPE:uint = 0;
      
      public static var STRING_TYPE:uint = 1;
      
      public static var OBJECT_TYPE:uint = 2;
      
      public static var DATE_TYPE:uint = 3;
      
      public static var BOOLEAN_TYPE:uint = 4;
      
      public static var XML_TYPE:uint = 5;
      
      public static var ARRAY_TYPE:uint = 6;
      
      public static var MAP_TYPE:uint = 7;
      
      public static var ANY_TYPE:uint = 8;
      
      public static var ROWSET_TYPE:uint = 11;
      
      public static var QBEAN_TYPE:uint = 12;
      
      public static var DOC_TYPE:uint = 13;
      
      public static var SCHEMA_TYPE:uint = 14;
      
      public static var FUNCTION_TYPE:uint = 15;
      
      public static var ELEMENT_TYPE:uint = 16;
      
      public static var BASE64_BINARY_TYPE:uint = 17;
      
      public static var HEX_BINARY_TYPE:uint = 18;
      
      public var name:String;
      
      public var dimensions:Array;
      
      public var namespaceURI:String;
      
      public var typeType:uint;
      
      public var partTypes:Object;
      
      private var _partTypesArray:Array;
      
      public var isWrappedArray:Boolean;
      
      public var simpleValue:Boolean;
      
      public var isAnonymous:Boolean;
      
      public var itemElement:QName;
      
      public var isOptional:Boolean;
      
      public var arrayType:DataType;
      
      public var isEncodedArray:Boolean;
      
      public var schemaType:DataType;
      
      public var qname:QName;
      
      public function DataType(param1:String = null, param2:uint = 2, param3:String = "http://www.w3.org/2001/XMLSchema")
      {
         super();
         this.name = param1;
         this.typeType = param2;
         this.namespaceURI = param3;
         this.qname = new QName(this.namespaceURI,this.name);
         this.isAnonymous = false;
         this.isOptional = false;
      }
      
      public function addPartType(param1:PartType) : void
      {
         if(partTypes == null)
         {
            partTypes = {};
         }
         if(param1.name != null && param1.name.length > 0)
         {
            partTypes[param1.name] = param1;
         }
         partTypesArray.push(param1);
      }
      
      public function toString() : String
      {
         var _loc1_:String = null;
         var _loc2_:uint = 0;
         _loc1_ = "DataType: name = " + name + "\n\ttypeType = " + typeType + "\n\tnamespaceURI = " + namespaceURI;
         if(partTypesArray)
         {
            _loc2_ = 0;
            while(_loc2_ < partTypesArray.length)
            {
               _loc1_ += "\n\tpartType[" + _loc2_ + "] = " + partTypesArray[_loc2_];
               _loc2_++;
            }
         }
         return _loc1_;
      }
      
      public function get partTypesArray() : Array
      {
         if(_partTypesArray == null)
         {
            _partTypesArray = [];
         }
         return _partTypesArray;
      }
   }
}

